<template>
    <nav class="header">
        <div class="logo">
            <router-link to="/">
                <img src="@/assets/logo/logo.png" alt="Logo">
            </router-link>
        </div>
        <div class="menu">
            <router-link class="menu-link" to="/">Home</router-link>
            <router-link class="menu-link" to="/about">About</router-link>
            <router-link class="menu-link" to="/recipes">My recipes</router-link>
            <router-link class="menu-link" to="/recipes/config">Create</router-link>
            <div class="user-info">
                <div v-if="getUser" class="user-container">
                    <img class="user-avatar" :src="getUser.photoURL" alt="User Avatar" />
                    <div class="user-details">
                        <!-- <span class="user-name">{{ getUser.displayName }}</span> -->
                        <button class="logout-button" @click="onLogout">Log out</button>
                    </div>
                </div>
                <div v-else>
                    <button class="login-button" @click="loginWithGoogle">Login</button>
                </div>
            </div>
        </div>
    </nav>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
export default {
    name: 'MyHeader',
    computed: {
        ...mapGetters('auth', ['getUser']),
    },
    methods: {
        ...mapActions('auth', ['logout', 'loginWithGoogle']),
        onLogout() {
            this.logout()
        },
    },
}
</script>

<style lang="scss" scoped>
$primary-color: #ffffff;

.header {
    background-color: rgba($primary-color, 0.1);
    backdrop-filter: blur(10px);
    padding: 15px 20px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.1);
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    z-index: 1000;

    .menu {
        display: flex;
        gap: 20px;
        font-size: 150%;
    }

    .logo img {
        max-height: 5vh;
        cursor: pointer;
    }

    .menu-link {
        text-decoration: none;
        color: $primary-color;
        font-weight: bold;
        padding: 10px;
        border-radius: 30px;
        transition: background-color 0.3s, color 0.3s;

        &:hover {
            background-color: $primary-color;
            color: green;
        }
    }

    .user-info {
        display: flex;
        align-items: center;

        .user-container {
            display: flex;
            align-items: center;

            .user-avatar {
                width: 30px;
                height: 30px;
                border-radius: 50%;
                margin-right: 10px;
            }

            .user-details {
                display: flex;
                flex-direction: column;

                .user-name {
                    font-weight: bold;
                    font-size: 50%;
                }
            }
        }
    }

    .login-button,
    .logout-button {
        font-weight: bold;
        font-size: 50%;
        padding: 8px 15px;
        border: none;
        border-radius: 30px;
        cursor: pointer;
        transition: background-color 0.3s;

        &.login-button {
            background-color: rgba(0, 128, 0, 0.51);
            color: $primary-color;

            &:hover {
                background-color: white;
                color: green;
            }
        }

        &.logout-button {
            background-color: rgba(255, 0, 0, 0.51);
            color: $primary-color;

            &:hover {
                background-color: white;
                color: red;
            }
        }
    }
}
</style>
